%define revision 5866
%define svndate 20070219.104945

%define svnversion 0.0.%(echo %{svndate}|awk -F. '{print $1}')
%define svnrelease 0.2.%{revision}svn

Summary: Object oriented programming environment for real-time audio and video processing
Name: supercollider
Version: %{svnversion}
Release: %{svnrelease}%{?dist}
License: GPL
Group: Applications/Multimedia
URL: http://supercollider.sourceforge.net/
Source0: SuperCollider3-%{revision}.tar.gz
Source1: supercollider-get-svn
Patch0: supercollider-x11path.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires: emacs
Packager: Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

BuildRequires: gcc-c++, autoconf, automake, libtool, pkgconfig, scons
BuildRequires: jack-audio-connection-kit-devel, libsndfile-devel, alsa-lib-devel
BuildRequires: emacs
%if "%{fedora}" == "3" || "%{fedora}" == "4"
BuildRequires: howl-devel
%endif
%if "%{fedora}" >= "5"
BuildRequires: avahi-devel
%endif
%if "%{fedora}" >= "5"
BuildRequires: libX11-devel
BuildRequires: libXt-devel
%else
BuildRequires: XFree86-devel
%endif

%description
SuperCollider is an object oriented programming environment for
real-time audio and video processing. It is one of the finest and most
versatile environments for signal processing and especially for
creating music applications of all kinds, such as complete
compositions, interactive performances, installations etc.

%package devel
Summary: Development files for SuperCollider
Group: Development/Libraries
Requires: supercollider = %{version}-%{release} pkgconfig 
Requires: jack-audio-connection-kit-devel alsa-lib-devel
Requires: libsndfile-devel
%if "%{fedora}" == "3" || "%{fedora}" == "4"
Requires: howl-devel
%endif
%if "%{fedora}" >= "5"
Requires: avahi-devel
%endif

%description devel
This package includes include files and libraries neede to develope
SuperCollider applications

%prep
%setup -q -n SuperCollider3-%{revision}
%if "%{fedora}" >= "7"
%patch0 -p1
%endif

%build
# remove all SVN directories
find . -type d -name .svn -printf "\"%h/%f\"\n" | xargs rm -rf 

# point the default location of help to the shared install
%{__perl} -p -i -e "s|~/SuperCollider/Help|%{_datadir}/SuperCollider/Help|g" linux/scel/el/sclang-help.el

scons PREFIX=%{_prefix} DEVELOPMENT=1 LID=1

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}

scons install PREFIX=%{_prefix} DEVELOPMENT=1 LID=1 DESTDIR=%{buildroot}

# install all source files, some plugin collections need this to build
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/
tar cf - source | (cd %{buildroot}%{_datadir}/SuperCollider/; tar xpf -)

# install default per-user configuration files
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.cfg %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.sc  %{buildroot}%{_datadir}/SuperCollider/configuration

# install sclang.cfg to /etc
%{__mkdir} -p %{buildroot}%{_sysconfdir}
%{__install} -m0644 linux/examples/sclang.cfg %{buildroot}%{_sysconfdir}/sclang.cfg

# add Platform to the example sclang configuration
%{__perl} -p -i -e "s|DefaultLibrary|DefaultLibrary\n\+%{_datadir}/SuperCollider/SCClassLibrary/Platform|g" %{buildroot}%{_sysconfdir}/sclang.cfg
# enable both crucial and JITlib by default, they are needed by other libraries
%{__perl} -p -i -e "s|#\+/usr/share/SuperCollider/SCClassLibrary/crucial|\+/usr/share/SuperCollider/SCClassLibrary/crucial|g" %{buildroot}%{_sysconfdir}/sclang.cfg
%{__perl} -p -i -e "s|#\+/usr/share/SuperCollider/SCClassLibrary/JITLib|\+/usr/share/SuperCollider/SCClassLibrary/JITLib|g" %{buildroot}%{_sysconfdir}/sclang.cfg
# add a line at the end to read (if exists) a user library configuration file
%{__perl} -p -i -e "s|# EOF|# include any user defined paths\n\:\\\$HOME/.sclang.scel.cfg\n\n# EOF|g" %{buildroot}%{_sysconfdir}/sclang.cfg

# copy the lone linux example to the examples directory
%{__cp} -p linux/examples/onetwoonetwo.sc build/examples

%if "%{fedora}" == "4"
# remove URL tag from pkgconfig files
%{__perl} -p -i -e "s|URL: http://supercollider.sourceforge.net||g" %{buildroot}%{_libdir}/pkgconfig/libsclang.pc
%{__perl} -p -i -e "s|URL: http://supercollider.sourceforge.net||g" %{buildroot}%{_libdir}/pkgconfig/libscsynth.pc
%endif

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc changes.rtf COPYING doc/*.rtf linux/README linux/NEWS
%doc build/examples
%{_bindir}/*
%{_libdir}/SuperCollider
%{_libdir}/*.so*
%dir %{_datadir}/SuperCollider
%{_datadir}/SuperCollider/SCClassLibrary
%{_datadir}/SuperCollider/Extensions
%{_datadir}/SuperCollider/Help
%{_datadir}/SuperCollider/configuration
%{_datadir}/emacs/site-lisp/*
%config %{_sysconfdir}/sclang.cfg
# examples already included in doc above
%exclude %{_docdir}/SuperCollider

%files devel
%defattr(-,root,root,-)
%{_libdir}/*.a
%{_includedir}/SuperCollider
%{_libdir}/pkgconfig/*
%{_datadir}/SuperCollider/source

%changelog
* Tue May  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.2.5866svn
- build on fc7, add patch0 to direct X11 path to right location

* Thu Mar  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.2.5866svn
- install all source files in the -devel package, some UGens (sc3-plugins)
  need the full source to build

* Wed Feb 21 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070219-0.1.5866svn
- updated to svn 5866

* Fri Jan 19 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070118-0.2.5811svn
- added Platform to /etc/sclang.conf (otherwise linux specific classes
  are not loaded)
- in fc4 remove URL tag from .pc files, the stock pkgconfig does not like
  them (later updates do but the build env does not use them)
- split -devel package, add proper requires (libhowl, avahi)

* Thu Jan 18 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20070118-0.1.5811svn
- switched to svn, updated to revision 5811
- added static scsynth.a lib to files list

* Mon Jan 15 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.1.cvs
- added missing libXt-devel dependency in fc5/6

* Thu Jan 11 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.5.cvs
- build on fc5 and fc6, remove howl-devel dependency as howl is no
  longer being developed or maintained. Replace with Avahi.

* Mon Jan  8 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.5.cvs
- added howl-devel build requirement (erased openmotif-devel)
- fix removal of CVS directories (a directory with spaces in it was
  being erased by mistake)

* Thu Jan  4 2007 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.4.cvs
- updated to cvs snapshot 2007.01.04
- add a line in /etc/sclang.cfg to include ~/.sclang.scel.cfg if exists

* Tue Dec 26 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.4.cvs
- really enable crucial and JITLib (needed \+ instead of just + in
  perl one-liner)

* Tue Dec 19 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.3.cvs
- install SCComplex.h file, Josh Parmenter's PV needs it (and anything
  using FFT_UGens.h)

* Mon Dec 18 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127-0.2.cvs
- enabled crucial and JITlib by default in /etc/sclang.conf

* Mon Nov 27 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20061127
- updated get-cvs script with new urls
- updated to cvs snapshot dated 20061127.105006

* Thu Jan  5 2006 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20060105
- updated to cvs snapshot 2006.01.05

* Fri Jul 15 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 
- added fc4/gcc4 patch posted by Russell Johnston

* Thu Jul 14 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050714
- updated to today's cvs
- add scons DEVELOPMENT option to get all the devel files built and
  installed

* Thu Jun 30 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050630
- updated to cvs snapshot 2005.06.30
- build is now scons based
- added patch for gcc4 build

* Thu May  5 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050505
- updated to cvs snapshot 2005.05.05
- added howl-devel build requirement on fc3
- create proper configuration file
- do not add ~/supercollider directory, users will need to create the
  proper subdirectories in the current directory before starting sclang

* Sun Oct  3 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- tried to --enable-lid but compile fails

* Thu Sep 30 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- cvs: 2004/09/30
- added patch to configure to add X11 library path search

* Fri Aug 13 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 2004.08.13-1
- downloaded new cvs snapshot
- many changes to spec file
- add .so.0 links for sclang and scsynth shared libraries

* Wed Jan 21 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 3.0-1.cvs
- Initial build.
- installs a /root/.sclang.cfg??
